Index: /palm/trunk/SOURCE/diffusion_u.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_u.f90	(revision 666)
+++ /palm/trunk/SOURCE/diffusion_u.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
 !
 ! Former revisions:
@@ -72,6 +72,6 @@
        INTEGER ::  i, j, k
        REAL    ::  kmym_x, kmym_y, kmyp_x, kmyp_y, kmzm, kmzp
-       REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_y(nys-1:nyn+1)
-       REAL    ::  tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
+       REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_y(nysg:nyng)
+       REAL    ::  tend(nzb:nzt+1,nysg:nyng,nxlg:nxrg)
        REAL, DIMENSION(:,:),   POINTER ::  usws, uswst
        REAL, DIMENSION(:,:,:), POINTER ::  km, u, v, w
@@ -177,5 +177,5 @@
                       &   - kmzm * ( ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k) &
                       &            + ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx     &
-                      &            )                                         &
+                      &            )                                          &
                       &   ) * ddzw(k)
              ENDDO
@@ -248,6 +248,6 @@
        INTEGER ::  i, j, k
        REAL    ::  kmym_x, kmym_y, kmyp_x, kmyp_y, kmzm, kmzp
-       REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_y(nys-1:nyn+1)
-       REAL    ::  tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
+       REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_y(nysg:nyng)
+       REAL    ::  tend(nzb:nzt+1,nysg:nyng,nxlg:nxrg)
        REAL, DIMENSION(nzb:nzt+1)      ::  usvs
        REAL, DIMENSION(:,:),   POINTER ::  usws, uswst
Index: /palm/trunk/SOURCE/diffusion_v.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_v.f90	(revision 666)
+++ /palm/trunk/SOURCE/diffusion_v.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
 !
 ! Former revisions:
@@ -70,6 +70,6 @@
        INTEGER ::  i, j, k
        REAL    ::  kmxm_x, kmxm_y, kmxp_x, kmxp_y, kmzm, kmzp
-       REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_x(nxl-1:nxr+1)
-       REAL    ::  tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
+       REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_x(nxlg:nxrg)
+       REAL    ::  tend(nzb:nzt+1,nysg:nyng,nxlg:nxrg)
        REAL, DIMENSION(:,:),   POINTER ::  vsws, vswst
        REAL, DIMENSION(:,:,:), POINTER ::  km, u, v, w
@@ -246,6 +246,6 @@
        INTEGER ::  i, j, k
        REAL    ::  kmxm_x, kmxm_y, kmxp_x, kmxp_y, kmzm, kmzp
-       REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_x(nxl-1:nxr+1)
-       REAL    ::  tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
+       REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_x(nxlg:nxrg)
+       REAL    ::  tend(nzb:nzt+1,nysg:nyng,nxlg:nxrg)
        REAL, DIMENSION(nzb:nzt+1)      ::  vsus
        REAL, DIMENSION(:,:),   POINTER ::  vsws, vswst
Index: /palm/trunk/SOURCE/diffusion_w.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_w.f90	(revision 666)
+++ /palm/trunk/SOURCE/diffusion_w.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
 !
 ! Former revisions:
@@ -64,7 +64,7 @@
        REAL    ::  kmxm_x, kmxm_z, kmxp_x, kmxp_z, kmym_y, kmym_z, kmyp_y, &
                    kmyp_z
-       REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_x(nxl-1:nxr+1), &
-                   km_damp_y(nys-1:nyn+1)
-       REAL    ::  tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
+       REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_x(nxlg:nxrg),        & 
+                   km_damp_y(nysg:nyng)
+       REAL    ::  tend(nzb:nzt+1,nysg:nyng,nxlg:nxrg)
        REAL, DIMENSION(:,:,:), POINTER ::  km, u, v, w
        REAL, DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  wsus, wsvs
@@ -211,7 +211,7 @@
        REAL    ::  kmxm_x, kmxm_z, kmxp_x, kmxp_z, kmym_y, kmym_z, kmyp_y, &
                    kmyp_z
-       REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_x(nxl-1:nxr+1), &
-                   km_damp_y(nys-1:nyn+1)
-       REAL    ::  tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
+       REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_x(nxlg:nxrg),        & 
+                   km_damp_y(nysg:nyng)
+       REAL    ::  tend(nzb:nzt+1,nysg:nyng,nxlg:nxrg)
        REAL, DIMENSION(nzb:nzt+1)      ::  wsus, wsvs
        REAL, DIMENSION(:,:,:), POINTER ::  km, u, v, w
Index: /palm/trunk/SOURCE/diffusivities.f90
===================================================================
--- /palm/trunk/SOURCE/diffusivities.f90	(revision 666)
+++ /palm/trunk/SOURCE/diffusivities.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
 ! 
 ! Former revisions:
@@ -54,5 +54,5 @@
     REAL, SAVE ::  phi_m = 1.0
 
-    REAL    ::  var(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
+    REAL    ::  var(nzb:nzt+1,nysg:nyng,nxlg:nxrg)
 
     REAL, DIMENSION(1:nzt) ::  l, ll, sqrt_e
@@ -73,6 +73,6 @@
 
     !$OMP DO
-    DO  i = nxl-1, nxr+1
-       DO  j = nys-1, nyn+1
+    DO  i = nxlg, nxrg
+       DO  j = nysg, nyng
 
 !
@@ -157,5 +157,5 @@
 
     sums_l_l(nzt+1,:,tn) = sums_l_l(nzt,:,tn)   ! quasi boundary-condition for
-                                                ! data output
+                                                  ! data output
 
     !$OMP END PARALLEL
@@ -167,6 +167,6 @@
 !-- values of the diffusivities are not needed
     !$OMP PARALLEL DO
-    DO  i = nxl-1, nxr+1
-       DO  j = nys-1, nyn+1
+    DO  i = nxlg, nxrg
+       DO  j = nysg, nyng
           km(nzb_s_inner(j,i),j,i) = km(nzb_s_inner(j,i)+1,j,i)
           km(nzt+1,j,i)            = km(nzt,j,i)
Index: /palm/trunk/SOURCE/disturb_field.f90
===================================================================
--- /palm/trunk/SOURCE/disturb_field.f90	(revision 666)
+++ /palm/trunk/SOURCE/disturb_field.f90	(revision 667)
@@ -4,5 +4,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
+! Calls of exchange_horiz are modified.
 !
 ! Former revisions:
@@ -44,9 +45,9 @@
 
     INTEGER ::  i, j, k
-    INTEGER ::  nzb_uv_inner(nys-1:nyn+1,nxl-1:nxr+1)
+    INTEGER ::  nzb_uv_inner(nysg:nyng,nxlg:nxrg)
 
     REAL    ::  randomnumber,                             &
-                dist1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
-                field(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
+                dist1(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+                field(nzb:nzt+1,nysg:nyng,nxlg:nxrg)
     REAL, DIMENSION(:,:,:), ALLOCATABLE ::  dist2
 
@@ -57,5 +58,5 @@
 !-- Create an additional temporary array and initialize the arrays needed
 !-- to store the disturbance
-    ALLOCATE( dist2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+    ALLOCATE( dist2(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
     dist1 = 0.0
     dist2 = 0.0
@@ -102,6 +103,5 @@
 !-- Exchange of ghost points for the random perturbation
 
-    CALL exchange_horiz( dist1 )
-
+    CALL exchange_horiz( dist1, nbgp )
 !
 !-- Applying the Shuman filter in order to smooth the perturbations.
@@ -128,5 +128,5 @@
 !-- Exchange of ghost points for the filtered perturbation.
 !-- Afterwards, filter operation and exchange of ghost points are repeated.
-    CALL exchange_horiz( dist2 )
+    CALL exchange_horiz( dist2, nbgp )
 
     DO  i = nxl, nxr
@@ -141,5 +141,5 @@
     ENDDO
 
-    CALL exchange_horiz( dist1 )
+    CALL exchange_horiz( dist1, nbgp )
 
 !
@@ -148,6 +148,6 @@
 !-- (diffusion criterion))
     IF ( TRIM( topography ) /= 'flat' )  THEN
-       DO  i = nxl-1, nxr+1
-          DO  j = nys-1, nyn+1
+       DO  i = nxlg, nxrg
+          DO  j = nysg, nyng
              dist1(nzb:nzb_uv_inner(j,i)+1,j,i) = 0.0
           ENDDO
@@ -157,6 +157,6 @@
 !
 !-- Random perturbation is added to the array to be disturbed.
-    DO  i = nxl-1, nxr+1
-       DO  j = nys-1, nyn+1
+    DO  i = nxlg, nxrg
+       DO  j = nysg, nyng
           DO  k = disturbance_level_ind_b-2, disturbance_level_ind_t+2
              field(k,j,i) = field(k,j,i) + dist1(k,j,i)
Index: /palm/trunk/SOURCE/exchange_horiz.f90
===================================================================
--- /palm/trunk/SOURCE/exchange_horiz.f90	(revision 666)
+++ /palm/trunk/SOURCE/exchange_horiz.f90	(revision 667)
@@ -1,8 +1,13 @@
- SUBROUTINE exchange_horiz( ar )
+ SUBROUTINE exchange_horiz( ar, nbgp_local)
 
 !------------------------------------------------------------------------------!
 ! Current revisions:
 ! -----------------
-! 
+! Dynamic exchange of ghost points with nbgp_local to ensure that no useless 
+! ghost points exchanged in case of multigrid. type_yz(0) and type_xz(0)
+! used for normal grid, the remaining types used for the several grid levels.
+! Exchange is done via MPI-Vectors with a dynamic value of ghost points which
+! depend on the advection scheme. Exchange of left and right PEs is 10% faster 
+! with MPI-Vectors than without. 
 !
 ! Former revisions:
@@ -41,10 +46,15 @@
     INTEGER, DIMENSION(MPI_STATUS_SIZE,4) ::  wait_stat
 #endif
-
-    REAL ::  ar(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
-
+    INTEGER :: i,nbgp_local
+    REAL, DIMENSION(nzb:nzt+1,nys-nbgp_local:nyn+nbgp_local, &
+                    nxl-nbgp_local:nxr+nbgp_local) ::  ar
 
     CALL cpu_log( log_point_s(2), 'exchange_horiz', 'start' )
 
+    IF ( exchange_mg == .TRUE. ) THEN
+      i = grid_level
+    ELSE
+      i = 0
+    END IF
 #if defined( __parallel )
 
@@ -56,6 +66,6 @@
 !--    within the PE memory
        IF ( bc_lr == 'cyclic' )  THEN
-          ar(:,nys:nyn,nxl-1) = ar(:,nys:nyn,nxr)
-          ar(:,nys:nyn,nxr+1) = ar(:,nys:nyn,nxl)
+          ar(:,:,nxl-nbgp_local:nxl-1) = ar(:,:,nxr-nbgp_local+1:nxr)
+          ar(:,:,nxr+1:nxr+nbgp_local) = ar(:,:,nxl:nxl+nbgp_local-1)
        ENDIF
 
@@ -65,18 +75,17 @@
 !
 !--    Send left boundary, receive right one
-       CALL MPI_ISEND(                                                     &
-               ar(nzb,nys-1,nxl), ngp_yz(grid_level), MPI_REAL, pleft,  0, &
-                          comm2d, req(1), ierr )
-       CALL MPI_IRECV(                                                       &
-               ar(nzb,nys-1,nxr+1), ngp_yz(grid_level), MPI_REAL, pright, 0, &
-                          comm2d, req(2), ierr )
+       CALL MPI_ISEND(ar(nzb,nys-nbgp_local,nxl),1,type_yz(i),pleft,0,comm2d,&
+                      req(1),ierr)
+       CALL MPI_IRECV(ar(nzb,nys-nbgp_local,nxr+1),1,type_yz(i),pright,0,&
+                     comm2d,req(2),ierr)
 !
 !--    Send right boundary, receive left one
-       CALL MPI_ISEND(                                                     &
-               ar(nzb,nys-1,nxr), ngp_yz(grid_level), MPI_REAL, pright, 1, &
-                          comm2d, req(3), ierr )
-       CALL MPI_IRECV(                                                       &
-               ar(nzb,nys-1,nxl-1), ngp_yz(grid_level), MPI_REAL, pleft,  1, &
-                          comm2d, req(4), ierr )
+
+
+       CALL MPI_ISEND(ar(nzb,nys-nbgp_local,nxr+1-nbgp_local),1,type_yz(i),pright, 1,  &
+                      comm2d, req(3), ierr )
+       CALL MPI_IRECV(ar(nzb,nys-nbgp_local,nxl-nbgp_local),1,type_yz(i),pleft,1,&
+                      comm2d,req(4), ierr)
+
        CALL MPI_WAITALL( 4, req, wait_stat, ierr )
 
@@ -89,6 +98,6 @@
 !--    within the PE memory
        IF ( bc_ns == 'cyclic' )  THEN
-          ar(:,nys-1,:) = ar(:,nyn,:)
-          ar(:,nyn+1,:) = ar(:,nys,:)
+          ar(:,nys-nbgp_local:nys-1,:) = ar(:,nyn-nbgp_local+1:nyn,:)
+          ar(:,nyn+1:nyn+nbgp_local,:) = ar(:,nys:nys+nbgp_local-1,:)
        ENDIF
 
@@ -98,18 +107,19 @@
 !
 !--    Send front boundary, receive rear one
-       CALL MPI_ISEND( ar(nzb,nys,nxl-1),   1, type_xz(grid_level), psouth, 0, &
+!--    MPI_ISEND initial send adress changed, type_xz() is sendet nbgp times
+
+       CALL MPI_ISEND( ar(nzb,nys,nxl-nbgp_local),1, type_xz(i), psouth, 0, &
                        comm2d, req(1), ierr )
-       CALL MPI_IRECV( ar(nzb,nyn+1,nxl-1), 1, type_xz(grid_level), pnorth, 0, &
+       CALL MPI_IRECV( ar(nzb,nyn+1,nxl-nbgp_local),1, type_xz(i), pnorth, 0, &
                        comm2d, req(2), ierr )
 !
 !--    Send rear boundary, receive front one
-       CALL MPI_ISEND( ar(nzb,nyn,nxl-1),   1, type_xz(grid_level), pnorth, 1, &
+       CALL MPI_ISEND( ar(nzb,nyn-nbgp_local+1,nxl-nbgp_local),1, type_xz(i), pnorth, 1, &
                        comm2d, req(3), ierr )
-       CALL MPI_IRECV( ar(nzb,nys-1,nxl-1), 1, type_xz(grid_level), psouth, 1, &
+       CALL MPI_IRECV( ar(nzb,nys-nbgp_local,nxl-nbgp_local),1, type_xz(i), psouth, 1, &
                        comm2d, req(4), ierr )
        call MPI_WAITALL( 4, req, wait_stat, ierr )
 
     ENDIF
-
 
 #else
@@ -118,16 +128,16 @@
 !-- Lateral boundary conditions in the non-parallel case
     IF ( bc_lr == 'cyclic' )  THEN
-       ar(:,nys:nyn,nxl-1) = ar(:,nys:nyn,nxr)
-       ar(:,nys:nyn,nxr+1) = ar(:,nys:nyn,nxl)
+        ar(:,:,nxl-nbgp_local:nxl-1) = ar(:,:,nxr-nbgp_local+1:nxr)
+        ar(:,:,nxr+1:nxr+nbgp_local) = ar(:,:,nxl:nxl+nbgp_local-1)
     ENDIF
 
     IF ( bc_ns == 'cyclic' )  THEN
-       ar(:,nys-1,:) = ar(:,nyn,:)
-       ar(:,nyn+1,:) = ar(:,nys,:)
+        ar(:,nys-nbgp_local:nys-1,:) = ar(:,nyn-nbgp_local+1:nyn,:)
+        ar(:,nyn+1:nyn+nbgp_local,:) = ar(:,nys:nys+nbgp_local-1,:)
     ENDIF
 
 #endif
-
     CALL cpu_log( log_point_s(2), 'exchange_horiz', 'stop' )
 
+
  END SUBROUTINE exchange_horiz
Index: /palm/trunk/SOURCE/exchange_horiz_2d.f90
===================================================================
--- /palm/trunk/SOURCE/exchange_horiz_2d.f90	(revision 666)
+++ /palm/trunk/SOURCE/exchange_horiz_2d.f90	(revision 667)
@@ -4,5 +4,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Dynamic exchange of ghost points with nbgp, which depends on the advection
+! scheme. Exchange between left and right PEs is now done with MPI-vectors.
 !
 ! Former revisions:
@@ -37,5 +38,6 @@
     IMPLICIT NONE
 
-    REAL ::  ar(nys-1:nyn+1,nxl-1:nxr+1)
+    REAL ::  ar(nysg:nyng,nxlg:nxrg)
+    INTEGER :: i
 
 
@@ -51,17 +53,18 @@
 !--    One-dimensional decomposition along y, boundary values can be exchanged
 !--    within the PE memory
-       ar(nys:nyn,nxl-1) = ar(nys:nyn,nxr)
-       ar(nys:nyn,nxr+1) = ar(nys:nyn,nxl)
+       ar(:,nxl-nbgp:nxl-1) = ar(:,nxr-nbgp+1:nxr)
+       ar(:,nxr+1:nxr+nbgp) = ar(:,nxl:nxl+nbgp-1)
 
     ELSE
 !
 !--    Send left boundary, receive right one
-       CALL MPI_SENDRECV( ar(nys,nxl),   ngp_y, MPI_REAL, pleft,  0, &
-                          ar(nys,nxr+1), ngp_y, MPI_REAL, pright, 0, &
+
+       CALL MPI_SENDRECV( ar(nysg,nxl), 1, type_y, pleft,  0, &
+                          ar(nysg,nxr+1), 1, type_y, pright, 0, &
                           comm2d, status, ierr )
 !
 !--    Send right boundary, receive left one
-       CALL MPI_SENDRECV( ar(nys,nxr),   ngp_y, MPI_REAL, pright,  1, &
-                          ar(nys,nxl-1), ngp_y, MPI_REAL, pleft,   1, &
+       CALL MPI_SENDRECV( ar(nysg,nxr+1-nbgp), 1, type_y, pright,  1, &
+                          ar(nysg,nxlg), 1, type_y, pleft,   1, &
                           comm2d, status, ierr )
     ENDIF
@@ -71,18 +74,20 @@
 !--    One-dimensional decomposition along x, boundary values can be exchanged
 !--    within the PE memory
-       ar(nys-1,:) = ar(nyn,:)
-       ar(nyn+1,:) = ar(nys,:)
+       ar(nys-nbgp:nys-1,:) = ar(nyn-nbgp+1:nyn,:)
+       ar(nyn+1:nyn+nbgp,:) = ar(nys:nys+nbgp-1,:)
 
     ELSE
 !
 !--    Send front boundary, receive rear one
-       CALL MPI_SENDRECV( ar(nys,nxl-1),   1, type_x, psouth, 0, &
-                          ar(nyn+1,nxl-1), 1, type_x, pnorth, 0, &
+
+       CALL MPI_SENDRECV( ar(nys,nxlg), 1, type_x, psouth, 0, &        !replace number of sended elements from 
+                          ar(nyn+1,nxlg), 1, type_x, pnorth, 0, &      ! nbgp to 1
                           comm2d, status, ierr )
 !
 !--    Send rear boundary, receive front one
-       CALL MPI_SENDRECV( ar(nyn,nxl-1),   1, type_x, pnorth, 1, &
-                          ar(nys-1,nxl-1), 1, type_x, psouth, 1, &
-                          comm2d, status, ierr )
+       CALL MPI_SENDRECV( ar(nyn+1-nbgp,nxlg), 1, type_x, pnorth, 1, &
+                          ar(nysg,nxlg), 1, type_x, psouth, 1, &
+                          comm2d, status, ierr )
+
     ENDIF
 
@@ -92,12 +97,13 @@
 !-- Lateral boundary conditions in the non-parallel case
     IF ( bc_lr == 'cyclic' )  THEN
-       ar(nys:nyn,nxl-1) = ar(nys:nyn,nxr)
-       ar(nys:nyn,nxr+1) = ar(nys:nyn,nxl)
+       ar(:,nxl-nbgp:nxl-1) = ar(:,nxr-nbgp+1:nxr)
+       ar(:,nxr+1:nxr+nbgp) = ar(:,nxl:nxl+nbgp-1)
     ENDIF
 
     IF ( bc_ns == 'cyclic' )  THEN
-       ar(nys-1,:) = ar(nyn,:)
-       ar(nyn+1,:) = ar(nys,:)
-    ENDIF
+       ar(nys-nbgp:nys-1,:) = ar(nyn-nbgp+1:nyn,:)
+       ar(nyn+1:nyn+nbgp,:) = ar(nys:nys+nbgp-1,:)
+    ENDIF
+
 
 #endif
@@ -106,9 +112,24 @@
 !-- Neumann-conditions at inflow/outflow in case of non-cyclic boundary
 !-- conditions
-    IF ( inflow_l .OR. outflow_l )  ar(:,nxl-1) = ar(:,nxl)
-    IF ( inflow_r .OR. outflow_r )  ar(:,nxr+1) = ar(:,nxr)
-    IF ( inflow_s .OR. outflow_s )  ar(nys-1,:) = ar(nys,:)
-    IF ( inflow_n .OR. outflow_n )  ar(nyn+1,:) = ar(nyn,:)
-
+    IF ( inflow_l .OR. outflow_l )  THEN
+       DO i=nbgp, 1, -1
+         ar(:,nxl-i) = ar(:,nxl)
+       END DO
+    END IF
+    IF ( inflow_r .OR. outflow_r )  THEN 
+       DO i=1, nbgp
+          ar(:,nxr+i) = ar(:,nxr)
+       END DO
+    END IF
+    IF ( inflow_s .OR. outflow_s )  THEN
+       DO i=nbgp, 1, -1
+         ar(nys-i,:) = ar(nys,:)
+       END DO
+    END IF
+    IF ( inflow_n .OR. outflow_n )  THEN
+       DO i=1, nbgp
+         ar(nyn+i,:) = ar(nyn,:)
+       END DO
+    END IF
     CALL cpu_log( log_point_s(13), 'exchange_horiz_2d', 'stop' )
 
@@ -134,5 +155,7 @@
     IMPLICIT NONE
 
-    INTEGER ::  ar(nys-1:nyn+1,nxl-1:nxr+1)
+    REAL ::  ar(nysg:nyng,nxlg:nxrg)
+    INTEGER :: i
+
 
 
@@ -154,12 +177,13 @@
 !
 !--    Send left boundary, receive right one
-       CALL MPI_SENDRECV( ar(nys,nxl),   ngp_y, MPI_INTEGER, pleft,  0, &
-                          ar(nys,nxr+1), ngp_y, MPI_INTEGER, pright, 0, &
+       CALL MPI_SENDRECV( ar(nysg,nxl), 1, type_y_int, pleft,  0, &
+                          ar(nysg,nxr+1), 1, type_y_int, pright, 0, &
                           comm2d, status, ierr )
 !
 !--    Send right boundary, receive left one
-       CALL MPI_SENDRECV( ar(nys,nxr),   ngp_y, MPI_INTEGER, pright,  1, &
-                          ar(nys,nxl-1), ngp_y, MPI_INTEGER, pleft,   1, &
-                          comm2d, status, ierr )
+       CALL MPI_SENDRECV( ar(nysg,nxr+1-nbgp), 1, type_y_int, pright,  1, &
+                          ar(nysg,nxlg), 1, type_y_int, pleft,   1, &
+                          comm2d, status, ierr )
+
     ENDIF
 
@@ -168,18 +192,21 @@
 !--    One-dimensional decomposition along x, boundary values can be exchanged
 !--    within the PE memory
-       ar(nys-1,:) = ar(nyn,:)
-       ar(nyn+1,:) = ar(nys,:)
+       ar(nysg:nys-1,:) = ar(nyn+1-nbgp:nyn,:)
+       ar(nyn+1:nyng,:) = ar(nys:nys-1+nbgp,:)
+
 
     ELSE
 !
 !--    Send front boundary, receive rear one
-       CALL MPI_SENDRECV( ar(nys,nxl-1),   1, type_x_int, psouth, 0, &
-                          ar(nyn+1,nxl-1), 1, type_x_int, pnorth, 0, &
-                          comm2d, status, ierr )
+       CALL MPI_SENDRECV( ar(nys,nxlg),1, type_x_int, psouth, 0, &
+                          ar(nyn+1,nxlg),1, type_x_int, pnorth, 0, &
+                          comm2d, status, ierr )
+
 !
 !--    Send rear boundary, receive front one
-       CALL MPI_SENDRECV( ar(nyn,nxl-1),   1, type_x_int, pnorth, 1, &
-                          ar(nys-1,nxl-1), 1, type_x_int, psouth, 1, &
-                          comm2d, status, ierr )
+       CALL MPI_SENDRECV( ar(nyn+1-nbgp,nxlg), nbgp, type_x_int, pnorth, 1, &
+                          ar(nysg,nxlg), nbgp, type_x_int, psouth, 1, &
+                          comm2d, status, ierr )
+
     ENDIF
 
@@ -194,6 +221,6 @@
 
     IF ( bc_ns == 'cyclic' )  THEN
-       ar(nys-1,:) = ar(nyn,:)
-       ar(nyn+1,:) = ar(nys,:)
+       ar(nysg:nys-1,:) = ar(nyn+1-nbgp:nyn,:)
+       ar(nyn+1:nyng,:) = ar(nys:nys-1+nbgp,:)
     ENDIF
 
